#include<iostream>
#include<cstring>
#include<cstdio>
#define ll long long
using namespace std;
const int N=100000+7;
int n,a[N],l,r,mid,c[3*N],t[N];
ll s[N];
int lowbit(int x){
	return x&-x;
}
void add(int x){
	for(int i=x;i<=2*N;i+=lowbit(i))
		c[i]++;
}
int query(int x){
	ll sum=0;
	for(int i=x;i>=1;i-=lowbit(i))
		sum+=c[i];
	return sum;
}
bool check(int now){
    for(int i=1;i<=2*N;i++)c[i]=0;		//用memset会出错 
	for(int i=1;i<=n;i++){
		s[i]=s[i-1]+(a[i]>=now ?1 :-1);
		//if(now==9)printf("%d ",s[i]);
	}
	//printf("\n");
	ll sum=0;
	for(int i=0;i<=n;i++){
		sum+=query(s[i]+N);
		add(s[i]+N);
	}
	//printf("%d %d\n",now,sum);
	return sum>=1ll*n*(n+1)/4;
}
int main(){
	//freopen("1.txt","r",stdin);
	cin>>n;
	for(int i=1;i<=n;i++){
		scanf("%d",&a[i]);
		r=max(r,a[i]);
	}
	while(l<=r){			//一定要用 <=，不然会漏情况 
		mid=(l+r)>>1;
		if(check(mid))l=mid+1;
		else r=mid-1;
	}
	printf("%d\n",r);
	return 0;
}
/*
3
10 30 20
*/
/*
10
5 9 5 9 8 9 3 5 4 3
*/